import { a5 as popScheduler, a6 as from } from './message-CyATHsMQ.js';
import { g as getSessionStorage, n as storageObservable } from './fetch-w4DphyvP.js';
import { b as browser } from './browser-polyfill-CQCiMlvl.js';
import { s as switchMap } from './switchMap-2-0PRSXl.js';

function of() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var scheduler = popScheduler(args);
    return from(args, scheduler);
}

const PREFIX = 'tab-available';
function getTabAvailableKey(tabId) {
    return `${PREFIX}:${tabId}`;
}
async function setTabAvailable(tabId, state) {
    await getSessionStorage().setItem(getTabAvailableKey(tabId), state);
    await browser.action.setBadgeText({
        tabId,
        text: '✓'
    });
}
async function removeTabAvailable(tabId, state) {
    const value = await getSessionStorage().getItem(getTabAvailableKey(tabId));
    if (value !== String(state)) {
        return;
    }
    await getSessionStorage().removeItem(getTabAvailableKey(tabId));
    await browser.action.setBadgeText({
        tabId,
        text: ''
    });
}
function tabAvailableObservable(tabId$) {
    return tabId$.pipe(switchMap((tabId)=>{
        if (!tabId) {
            return of(undefined);
        }
        const key = getTabAvailableKey(tabId);
        return storageObservable(getSessionStorage(), key);
    }));
}

export { removeTabAvailable as r, setTabAvailable as s, tabAvailableObservable as t };
